package tech.loedige;

public abstract class SynchronousKeyStreamGenerator extends KeyStreamGenerator{

    @Override
    final byte getNextKeyStreamByte(byte mByte){
        return getNextKeyStreamByte();
    }

    /**
     * Berechnung des nächsten Schlüsselstrombytes.
     * (Entspricht eines einmaligen Aufrufs der
     * Update-Funktion s und der Extraktions-Funktion S.)
     *
     * @return Nächstes Schlüsselstrombyte15
     */
    abstract byte getNextKeyStreamByte();
    /**
     * Generierung einer vorgegebenen Anzahl weiterer
     * Schlüsselstrombytes. (Entspricht einer entsprechenden
     * Anzahl von Aufrufen der Funktionen s und S.)
     *
     * @param noOfBytes Anzahl der zu generierenden
     * Schlüsselstrombytes
     * @return Die nächsten noOfBytes Bytes des
     * Schlüsselstroms
     */
    public byte[] getNextKeyStreamBytes(int noOfBytes) {
        byte[] keyStream = new byte[noOfBytes];
        for (int i = 0; i < noOfBytes; ++i) {
            keyStream[i] = getNextKeyStreamByte();
        }
        return keyStream;
    }
}
